require "import"
import "android.content.Context"
import "android.content.Intent"
import "java.util.Locale"
import "android.speech.SpeechRecognizer"
import "android.speech.RecognitionListener"
import "android.speech.RecognizerIntent"

function destroy(recognizer)
if recognizer then
recognizer.destroy()
recognizer = nil
end
return true
end

function startSpeech()
local speech = SpeechRecognizer.createSpeechRecognizer(this)
local listener = RecognitionListener {
onResults = function(results)
local resultArray = results.getParcelableArrayList(SpeechRecognizer.RESULTS_RECOGNITION)
if resultArray ~= nil and resultArray.size() > 0 then
local spokenText = changeWords(resultArray.get(0))
local editText = service.getEditText()
service.insertText(editText, spokenText .. "")
service.speak(spokenText)
end
destroy(speech)
end,
onError = function()
destroy(speech)
return false
end
}
local intent = Intent(RecognizerIntent.ACTION_RECOGNIZE_SPEECH)
intent.putExtra(RecognizerIntent.EXTRA_LANGUAGE_MODEL, RecognizerIntent.LANGUAGE_MODEL_FREE_FORM)
intent.putExtra(RecognizerIntent.EXTRA_LANGUAGE, Locale.getDefault())
intent.putExtra(RecognizerIntent.EXTRA_CALLING_PACKAGE, this.getPackageName())
speech.startListening(intent)
speech.setRecognitionListener(listener)
return true
end

function changeWords(text)
local changeWordsTable = {
["my full name"] = "Hemant Logically",
["my first name"] = "Hemant",
["my last name"] = "Logically",
["my email id"] = "hemantlogically@gmail.com",
["my mobile number"] = "+91 98123 98123",
["my country name"] = "United States of America, USA",
["my telegram handle"] = "@hemantlogically",
["my full address"] = "House No. 10, Silicon Valley Street, Washington DC, USA",
["my youtube channel"] = "CSR With MK",
["my qualification"] = "B. Tech, Computer Science",
["george"] = "JAWS",
["jose"] = "JAWS",
["nvidia"] = "NVDA",
["nvda"] = "NVDA",
["jishu"] = "Jieshuo",
["jisu"] = "Jieshuo",
["g sho"] = "Jieshuo",
["ji show"] = "Jieshuo",
["new line"] = "\n",
["new paragraph"] = "\n\n",
["question symbol"] = "? ",
["questions symbol"] = "? ",
["fullstop"] = ".",
["full stop"] = ".",
["fold stop"] = ".",
["food stop"] = ".",
["comma"] = ",",
["coma"] = ",",
["kama"] = ",",
["colon"] = ":",
["colen"] = ":",
["colan"] = ":",
["bang symbol"] = "! ",
["bank symbol"] = "! ",
["at symbol"] = "@",
["ate symbol"] = "@",
["hash symbol"] = "#",
["has symbol"] = "#",
["star symbol"] = "*",
["dollar symbol"] = "$",
["doller symbol"] = "$",
["rupee symbol"] = "₹",
["rupees symbol"] = "₹",
["rupi symbol"] = "₹",
["backflash"] = "\\",
["back flash"] = "\\",
["backless"] = "\\",
["backlash"] = "\\",
["more than symbol"] = ">",
["mordhan symbol"] = ">",
["less than symbol"] = "<",
["space bar"] = " ",
["plus symbol"] = "+",
["left round"] = "(",
["right round"] = ")",
["left square"] = "[",
["right square"] = "]",
["left curly"] = "{",
["left kar li"] = "{",
["right curly"] = "}",
["right kar li"] = "}",
["quote"] = "\"",
["coat"] = "\"",
["court"] = "\"",
["and symbol"] = "&",
["percentage"] = "%%",
["pipe"] = "|",
["vertical bar"] = "|",
["percent symbol"] = "%%"
}
for originalWord, replacementWord in pairs(changeWordsTable) do
local pattern = originalWord:gsub(
"(%a)",
function(char)
return "[" .. char:lower() .. char:upper() .. "]"
end
)
text = text:gsub(pattern, replacementWord)
end
text = text:gsub("^%l", string.upper)

text = text:gsub("([!?.:;])(%s+)(%l)", function(punct, spaces, letter)
    return punct .. spaces .. string.upper(letter)
end)


if text:match("%w$") then
text = text .. ". "
end

text = text:gsub("(%s)([(){}%[%]@#%$%%&*\\|\"<>!:,.?])", "%2")
text = text:gsub("([(){}%[%]@#%$%%&*\\|\"<>₹])%s", "%1")

return text
end

startSpeech()
